var Deck = Backbone.Collection.extend({
    model: Card,
    initialize: function() {
        this.currentIndex = 0;
        this.trigger('index:current:set');
    },
    current: function() {
        if (this.length < 1) return false;
        return this.at(this.currentIndex);
    },
    hasPrevious: function () {
        return this.currentIndex > 0
    },
    hasNext: function() {
        if (this.length < 2) return false;
        return (this.currentIndex+1) < this.models.length;
    },
    previous: function() {
        if (this.hasPrevious()) {
            this.currentIndex--;
			$('#numeri').text(this.currentIndex+1);
            this.trigger('index:current:set');
            this.trigger('index:previous');
            if (!this.hasPrevious()) {
                this.trigger('index:first');
            }
            return this.current();
        };
        return false;
    },
    next: function() {
        if (this.hasNext()) {
            this.currentIndex++;
			$('#numeri').text(this.currentIndex+1);
            this.trigger('index:current:set');
            this.trigger('index:next');
            if (!this.hasNext()) {
                this.trigger('index:last');
            }
            return this.current();
        };
        return false;
    },
    restart: function() {
        this.currentIndex = 0;
        this.trigger('index:restart');
        this.trigger('index:current:set');
    },
    seek: function(index) {
        this.currentIndex = index;
        this.trigger('index:current:set');
        return this.current();
    }
});
