var CardView = Backbone.View.extend({
    template: _.template($("#card_template").html()),
    className: 'card out-right animate',
    events: {
        'click': 'toggleSide'
    },
    initialize: function(options) {
        this.parentView = options.parentView;
        this.side = 'front';
		this.consegnaM=this.model.get('consegnaMazzo')
        this.rendered = false;
        this.hide();

        _.bindAll(this, "hide", "onEndFlip", "dispatchKeyUp", "setWidth", "onEndSlideIn", "onEndSlideOut");

        this.parentView.on('rendered', this.setIntervalAlign, this);
        this.parentView.on('card:'+this.model.get('id')+":unload", this.moveOut, this);
        this.parentView.on('card:'+this.model.get('id')+":unload", this.unbindKeyUp, this);
        this.parentView.on('splitView', this.onSplitView, this);
        this.parentView.on('singleView', this.onSingleView, this);

        this.on("ready", this.bindKeyUp, this);

        $('body').bind('keyup', this.dispatchKeyUp);
		
    },
    render: function() {
        if (!this.rendered) {
            var html = this.template();
			$(this.el).append("<div id=\"consegnaMazzo\">"+this.consegnaM+"</div>");
			$(this.el).append(html);
			
            frontFace = new FaceView({
                parentView: this,
                model: this.model,
                side: 'front',
                el: this.$('.front')
            }).render();
            backFace = new FaceView({
                parentView: this,
                model: this.model,
                side: 'back',
                el: this.$('.back')
            }).render();

            this.faces = {
                front: frontFace,
                back: backFace
            }
            if (!Modernizr.csstransitions) {
                setInterval(this.setWidth, 250);
            }
            this.rendered = true;
			//this.$('.content').vAlign();
        }
        return this;
    },
    currentFace: function() {
        return this.faces[this.side];
    },
     /*setIntervalAlign: function() {
        this.vAlignPID = setInterval(this.centerCard, 250);
    },
    centerCard: function() {
        if (!this.parentView.splitView || window.orientation == 'landscape') {
            mtop = ($(this.el).parent().height() - 390) / 2;
            $(this.el).css('margin-top', mtop);        
        } else {
            $(this.el).css('margin-top', '');
        }
    },*/
    show: function() {
        if (Modernizr.csstransforms) {
            $(this.el).show();
        } else {
            $(this.el).removeClass('hide');
        }
        this.trigger("show:"+this.side);
    },
    hide: function() {
        $(this.el).addClass('hide');
        this.trigger("hide");
    },
    dispatchKeyUp: function(e) {
        this.trigger('keyup', e);
    },
    bindKeyUp: function() {
        this.on('keyup', this.onKeyUp, this);
    },
    unbindKeyUp: function() {
        this.off('keyup', this.onKeyUp, this);
    },
    onKeyUp: function(e) {
        if ($(this.el).is(':visible')) {
            if (e.keyCode == "32") {
                this.toggleSide(e);
            }
        }
    },
    onSplitView: function(e) {
        if (this.selected) {
            this.trigger("show:front");
            this.trigger("show:back");
        }
    },
    onSingleView: function(e) {
        if (this.selected) {
            this.trigger("hide");
            this.trigger("show:"+this.side);
        }
    },
    bindSlidingIn: function() {
        $(this.el).bind('webkitTransitionEnd', this.onEndSlideIn);
        $(this.el).bind('transitionend', this.onEndSlideIn);
    },
    bindSlidingOut: function() {
        $(this.el).bind('webkitTransitionEnd', this.onEndSlideOut);
        $(this.el).bind('transitionend', this.onEndSlideOut);
    },
    onEndSlideIn: function(e) {
        if (e != undefined) {
            $(e.currentTarget).unbind('webkitTransitionEnd');
            $(e.currentTarget).unbind('transitionend');
        }
        $(this.el).removeClass('out-right');
        this.trigger("ready");
        this.trigger("slide:end");
        this.trigger("slide:end:"+this.side);
        this.parentView.moving = false;
        this.parentView.trigger("card:load");
        this.selected = true;
    },
    onEndSlideOut: function(e) {
        if (e != undefined) {
            $(e.currentTarget).unbind('webkitTransitionEnd');
            $(e.currentTarget).unbind('transitionend');
        }
        $(e.currentTarget).hide();
        this.selected = false;
    },
    bindFlipping: function(el, func) {
        $(el).bind('webkitTransitionEnd', this.onEndFlip);
        $(el).bind('transitionend', this.onEndFlip);
    },
    onEndFlip: function(e) {
        $(e.currentTarget).unbind('webkitTransitionEnd');
        $(e.currentTarget).unbind('transitionend');
        this.trigger("flip");
        this.trigger("flip:"+this.side);
        this.trigger("flip:"+this.side+":end");
        this.parentView.trigger("card:flip");
    },
    toggleSide: function(e) {
        if (e != undefined) {
            e.preventDefault();
        }
        if (!this.parentView.splitView) {
            new_side = this.side == 'front' ? 'back' : 'front';
            if (this.side != new_side) {
                this.trigger("flip:start");
                this.trigger("flip:"+this.side+":start");
                old_side = this.side;
                this.side = new_side;

                if (Modernizr.csstransforms3d) {
                    this.bindFlipping(this.el);
                }
                
                $(this.el).removeClass(old_side).addClass(new_side);
                
                if (!Modernizr.csstransforms3d) {
                    this.trigger("flip");
                    this.trigger("flip:"+this.side);
                    this.trigger("flip:"+this.side+":end");
                    this.parentView.trigger("card:flip");
                }
            }
        }
    },
    moveOut: function(direction, animate) {
        if (animate) {
            this.trigger("slide:start");
            this.trigger("slide:start:"+this.side);
            this.show();
            this.bindSlidingOut();
            $(this.el).addClass('animate');
        } else {
            $(this.el).removeClass('animate');
        }
        $(this.el).addClass('out-'+direction);
    },
    cssTransitionsMoveIn: function(animate) {
        if (animate) {
            this.show();
            $(this.el).addClass('animate');
        } else {
            $(this.el).removeClass('animate');
        }
        $(this.el).offset().top;  // forces DOM update.
        $(this.el).removeClass('out-left out-right');
    },
    setWidth: function() {
        if (!Modernizr.csstransitions) {
            w = $(window).width() - 300;
        
            $(this.el).css({
                'width': w
            });
        }
    }
});
