var TimerButtonView = Backbone.View.extend({
    events: {
        "click": "toggleTime"
    },
    initialize: function(options) {
        this.parentView = options.parentView;
        this.model.on('end', this.onTimeOver, this);
        this.model.on('start', this.onStartTime, this);
        this.model.on('pause', this.onPauseTime, this);
        this.model.on('stop', this.onStopTime, this);
    },
    show: function() {
        $(this.el).show();
    },
    hide: function() {
        $(this.el).hide();
    },
    onTimeOver: function() {
        $(this.el).removeClass('running btn-success btn-inverse').addClass('btn-danger');
    },
    onStartTime: function() {
        this.$('.title').text('Stop');
        $(this.el).addClass('running btn-success').removeClass('btn-danger btn-inverse');
    },
    onPauseTime: function() {
        this.$('.title').text('Start');
        $(this.el).addClass('running btn-inverse').removeClass('btn-danger btn-success');
    },
    onStopTime: function() {
        this.$('.title').text('Start');
        $(this.el).addClass('running btn-inverse').removeClass('btn-danger btn-success');
    },
    toggleTime: function(e) {
        e.preventDefault();
        if (this.model.running) {
            this.model.pause();
        } else {
            this.model.start();
        }
    }
});
